							 ;;Rev 3.30 Modification
;Equates for CMOS.							   
									  
;----------------------------------------				  
;	CMOS EQUATES FOR THIS SYSTEM	:				  
;------------------------------------------------------------------------------- 
CMOS_PORT	EQU	070H		; I/O ADDRESS OF CMOS ADDRESS PORT	 
CMOS_DATA	EQU	071H		; I/O ADDRESS OF CMOS DATA PORT 	 
NMI		EQU	10000000B	; DISABLE NMI INTERRUPTS MASK - 	 
					;  HIGH BIT OF CMOS LOCATION ADDRESS	 
										 
;---------- CMOS TABLE LOCATION ADDRESS'S ## ----------------------------------- 
CMOS_SECONDS	EQU	000H		; SECONDS				 
CMOS_SEC_ALARM	EQU	001H		; SECONDS ALARM  ## NOTE:  ALL LOCATIONS 
CMOS_MINUTES	EQU	002H		; MINUTES	      | IN THE CMOS AREA 
CMOS_MIN_ALARM	EQU	003H		; MINUTES ALARM       | ARE IBM USE ONLY 
CMOS_HOURS	EQU	004H		; HOURS 	      | AND  SUBJECT  TO 
CMOS_HR_ALARM	EQU	005H		; HOURS ALARM	      | CHANGE. ONLY THE 
CMOS_DAY_WEEK	EQU	006H		; DAY OF THE WEEK     | POST & BIOS CODE 
CMOS_DAY_MONTH	EQU	007H		; DAY OF THE MONTH    | SHOULD	DIRECTLY 
CMOS_MONTH	EQU	008H		; MONTH 	      | ACCESS LOCATIONS 
CMOS_YEAR	EQU	009H		; YEAR (TWO DIGITS)   | IN CMOS STORAGE. 
CMOS_REG_A	EQU	00AH		; STATUS REGISTER A   '----------------- 
CMOS_REG_B	EQU	00BH		; STATUS REGISTER B  ALARM		 
CMOS_REG_C	EQU	00CH		; STATUS REGISTER C  FLAGS		 
CMOS_REG_D	EQU	00DH		; STATUS REGISTER D  BATTERY		 
CMOS_DIAG	EQU	00EH		; POST DIAGNOSTIC STATUS RESULTS BYTE	 
CMOS_SHUT_DOWN	EQU	00FH		; SHUTDOWN STATUS COMMAND BYTE		 
CMOS_DISKETTE	EQU	010H		; DISKETTE DRIVE TYPE BYTE	      ;  
;		EQU	011H		; - RESERVED			      ;C 
CMOS_DISK	EQU	012H		; FIXED DISK TYPE BYTE		      ;H 
;		EQU	013H		; - RESERVED			      ;E 
CMOS_EQUIP	EQU	014H		; EQUIPMENT WORD LOW BYTE	      ;C 
CMOS_B_M_S_LO	EQU	015H		; BASE MEMORY SIZE - LOW BYTE (X1024) ;K 
CMOS_B_M_S_HI	EQU	016H		; BASE MEMORY SIZE - HIGH BYTE	      ;S 
CMOS_E_M_S_LO	EQU	017H		; EXPANSION MEMORY SIZE - LOW BYTE    ;U 
CMOS_E_M_S_HI	EQU	018H		; EXPANSION MEMORY SIZE - HIGH BYTE   ;M 
CMOS_DISK_1	EQU	019H		; FIXED DISK TYPE - DRIVE C EXTENSION ;E 
CMOS_DISK_2	EQU	01AH		; FIXED DISK TYPE - DRIVE D EXTENSION ;D 
;		EQU	01BH		; - 1BH THROUGH 2DH - RESERVED	      ;  
CMOS_CKSUM_HI	EQU	02EH		; CMOS CHECKSUM - HIGH BYTE	      ;* 
CMOS_CKSUM_LO	EQU	02FH		; CMOS CHECKSUM - LOW BYTE	      ;* 
CMOS_U_M_S_LO	EQU	030H		; USABLE MEMORY ABOVE 1 MEG - LOW BYTE	 
CMOS_U_M_S_HI	EQU	031H		; USABLE MEMORY ABOVE 1 MEG - HIGH BYTE  
CMOS_CENTURY	EQU	032H		; DATE CENTURY BYTE (BCD)		 
CMOS_INFO128	EQU	033H		; 128KB INFORMATION STATUS FLAG BYTE	 
;		EQU	034H		; - 34H THROUGH 3FH - RESERVED		 
;										 
							;;End of Modification									 
